function PlacesPreviewTreeView(view,tree) {
  //dump("new places tree view\n");
  this._treeType = tree;
  this._view = view;
  for (var p in view){
    try{
      if (!(p in this)){
        var type = (typeof view[p]);
        if (type == "function"){
          this[p] = function(){
            var name = arguments.callee.name;
            return this._view[name].apply(this._view,arguments);
          }
          this[p].name = p;
        }
        else{
          var funcGet = function() {
            var name = arguments.callee.name;
            return view[name];
          }
          funcGet.name = p;
          var funcSet = function(x) {
            var name = arguments.callee.name;
            view[name] = x;
          }
          funcSet.name = p;
          this.__defineGetter__(p, funcGet);
          this.__defineSetter__(p, funcSet);
        }
      }
    }catch(e){
      dump("PlacesPreviewTreeView error: "+e+"\n");
    }
  }
}
PlacesPreviewTreeView.prototype = {
  itemInserted: function(parent, item, newIndex) {
    this.LOG("item inserted: "+item.title);
    this.lastItem = item.itemId;
    this._view.itemInserted.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay(true);
    if (PlacesPreviewUtils.selected == "thumbnails"){
      /* select inserted item */
      ThumbView.selectNode(item);
    }
  },
  itemRemoved: function(parent, item, oldIndex) {
    this.LOG("item removed: "+item.title);
    this.lastItem = item.itemId;
    this._view.itemRemoved.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay(true);
  },
  itemChanged: function(item) {
    this.LOG("item changed: "+item.title);
    this._view.itemChanged.apply(this._view,arguments);
  },
  itemReplaced: function(parent, oldItem, newItem, index) {
    this.LOG("itemReplaced: " + newItem.uri);
    this.lastItem = item.itemId;
    this._view.itemReplaced.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay(true);
  },
  itemMoved: function(item, oldParent, oldIndex, newParent, newIndex) {
    this.LOG("item moved\n");
    this.lastItem = item.itemId;
    this._view.itemMoved.apply(this._view,arguments);
    PlacesPreviewUtils.utils.refreshDisplay(true);
  },
  containerOpened: function(item) {
    this.LOG("container opened: "+item.title);
    this._view.containerOpened.apply(this._view,arguments);
    if (!PlacesPreviewUtils.utils.updatedSelection){
      setTimeout(function(){
        if (PlacesPreviewUtils.utils)
          PlacesPreviewUtils.utils.refreshDisplay(true);
      },0);
    }
  },
  containerClosed: function(item) {
    this.LOG("container closed: "+item.title);
    this._view.containerClosed.apply(this._view,arguments);
  },
  invalidateContainer: function(item) {
    this.LOG("invalidateContainer(): "+item.title);
    this._view.invalidateContainer.apply(this._view,arguments);
  },
  invalidateAll: function() {
    this.LOG("invalidateAll\n");
    this._view.invalidateAll.apply(this._view,arguments);
    setTimeout(function(){
      PlacesPreviewUtils.utils.refreshDisplay(true);
    },0);
  },
  get sortingMode(){
    return this._result.sortingMode;
  },
  //sortingChanged: function(sortingMode) {
  //  //dump("tree: "+this._treeType+" - "+"sorting changed: "+sortingMode+"\n");
  //  this._view.sortingChanged.apply(this._view,arguments);
  //}
  LOG : function(aText){
    dump("tree: "+this._treeType+" - "+aText+"\n");
  }
};

function PlacesThumbView(aShowRow, aFlatList){
  
}
PlacesThumbView.prototype = {
  addViewObserver: function(observer, ownsWeak) {},
  removeViewObserver: function(observer) {}
};
